/*
 * Copyright 1996-2002 netFluid Technology Ltd
 *
 * Goldwater is written and maintained by netFluid Technology Ltd.
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * $Revision: 1.4 $  $Date: 2003/01/04 12:43:19 $
 * --------------------------------------------------------------------------
 */
#ifndef DATA_CHAIN_H
#define DATA_CHAIN_H

#include <phlib/xl_types.h>

typedef enum {
  E_DCNOERROR  = 0,
  E_DCINTERNAL = -1,
  E_DCMEMORY   = -2,
  E_DCNOSPACE  = -3
} DCError;

typedef struct {
  int mapsize;   /* Number of bytes in block map     */
  int freespace; /* Freespace available in chain     */
  int bsize;     /* Size of a datablock              */
  int o_map;     /* Offset to free block map (bytes) */
  int o_index;   /* Offset to chain index    (bytes) */
  int o_data;    /* Offest to data blocks    (bytes) */
} DCCtrl;


/* Prototypes
 */
void xl_DataChain_init      ( DCCtrl *dc, int blocksize, int numblocks );
int  xl_DataChain_store     ( DCCtrl *dc, char* data, int len, int *dblk );
int  xl_DataChain_append    ( DCCtrl *dc, char *data, int len, int *olblk );
int  xl_DataChain_free      ( DCCtrl *dc, int block );
int  xl_DataChain_free_block( DCCtrl *dc, int block );
int  xl_DataChain_get_data  ( DCCtrl *dc, int block,  char **dptr, int *len );

int  xl_DataChain_mem_req   ( int blocksize, int numblocks );

#endif
