/* 
 * Copyright 1996-2002 netFluid Technology Ltd
 *
 * Goldwater is written and maintained by netFluid Technology Ltd.
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * $Revision: 1.4 $  $Date: 2003/01/04 12:43:19 $
 * ---------------------------------------------------------------------------
 */

#define RMAX_LEN 65536

struct dbdstem {
  char type;           /* Data field type */
  char seqlen[2];      /* 15bit  Data length MSB..LSB b16=0 */
  char data[RMAX_LEN]; /* Data segment */
};


struct dbrec {
  char len[2];              /* 15 bit rec len MSB..LSB  b15 = lock bit  */
  char crc;                 /* 8bit crc                    */
  char keylen;              /* Length of key 1..255        */
  char data_stem[RMAX_LEN]; /* KEY and Data stem           */
};

typedef struct dbrec DBrec;

#define OFF_KEY_START   ( 0 )

#if 0
#define VAL_KEY_LEN(x)   ( (int)(((DBrec*)x.s)->keylen) )
#else
#define VAL_KEY_LEN(x)	32
#endif

#define PTR_KEY_START(x) (x.s + OFF_KEY_START) 
