/*
 * Copyright 1996-2002 netFluid Technology Ltd
 *
 * Goldwater is written and maintained by netFluid Technology Ltd.
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * $Revision: 1.7 $  $Date: 2003/01/04 12:43:19 $
 *
 * Author: Dave Zambonini
 * ---------------------------------------------------------------------------
 */

#ifndef MEMORY_DEBUG_H
#define MEMORY_DEBUG_H

#include <malloc.h> /* For memory functions */
#include <stdlib.h> /* For size_t           */

#include <phlib/xl_malloc.h> 

/* Unless we're not debugging, replace existing funcs. with macros:- */
#ifdef MEMDEBUG
#  warning ****** MEMORY DEBUGGING ENABLED *****

#  define  malloc(x)    malloc_debug(__FILE__,__LINE__,(x))
#  define  calloc(x,y)  calloc_debug(__FILE__,__LINE__,(x),(y))
#  define realloc(x,y) realloc_debug(__FILE__,__LINE__,(x),(y))
#  define    free(x)      free_debug(__FILE__,__LINE__,(x))

#  ifndef XL_WITHIN_MALLOC_C
#    define xl_malloc(x)  malloc_debug(__FILE__,__LINE__,(x))
#    define xl_free(x)      free_debug(__FILE__,__LINE__,(x))
#  endif
#endif

#ifdef __cplusplus
  extern "C" {
#endif

void *malloc_debug(const char*,unsigned,size_t);
void *calloc_debug(const char*,unsigned,size_t,size_t);
void *realloc_debug(const char*,unsigned,void*,size_t);
void free_debug(const char*,unsigned,void*);

#ifdef __cplusplus
  } /* extern "C" */
#endif

#endif /* MEMORY_DEBUG_H */

